diff --git a/sys/dev/netif/em/if_em.c b/sys/dev/netif/em/if_em.c
index f4b6381dbc..0e8cc39764 100644
--- a/sys/dev/netif/em/if_em.c
+++ b/sys/dev/netif/em/if_em.c
@@ -1,7 +1,7 @@
 /*
  * Copyright (c) 2004 Joerg Sonnenberger <joerg@bec.de>.  All rights reserved.
  *
- * Copyright (c) 2001-2014, Intel Corporation
+ * Copyright (c) 2001-2015, Intel Corporation
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -117,7 +117,7 @@
 #define DEBUG_HW 0
 
 #define EM_NAME	"Intel(R) PRO/1000 Network Connection "
-#define EM_VER	" 7.4.2"
+#define EM_VER	" 7.6.2"
 
 #define _EM_DEVICE(id, ret)	\
 	{ EM_VENDOR_ID, E1000_DEV_ID_##id, ret, EM_NAME #id EM_VER }
@@ -246,7 +246,7 @@ static const struct em_vendor_info em_vendor_info_array[] = {
 	EM_EMX_DEVICE(PCH_SPT_I219_V),
 	EM_EMX_DEVICE(PCH_SPT_I219_LM2),
 	EM_EMX_DEVICE(PCH_SPT_I219_V2),
-	EM_EMX_DEVICE(PCH_SPT_I219_LM3),
+	EM_EMX_DEVICE(PCH_LBG_I219_LM3),
 	EM_EMX_DEVICE(PCH_SPT_I219_LM4),
 	EM_EMX_DEVICE(PCH_SPT_I219_V4),
 	EM_EMX_DEVICE(PCH_SPT_I219_LM5),
@@ -322,6 +322,9 @@ static void	em_update_link_status(struct adapter *);
 static void	em_smartspeed(struct adapter *);
 static void	em_set_itr(struct adapter *, uint32_t);
 static void	em_disable_aspm(struct adapter *);
+static void	em_flush_tx_ring(struct adapter *);
+static void	em_flush_rx_ring(struct adapter *);
+static void	em_flush_txrx_ring(struct adapter *);
 
 /* Hardware workarounds */
 static int	em_82547_fifo_workaround(struct adapter *, int);
@@ -501,12 +504,19 @@ em_attach(device_t dev)
 	struct ifnet *ifp = &adapter->arpcom.ac_if;
 	int tsize, rsize;
 	int error = 0;
+	int cap;
 	uint16_t eeprom_data, device_id, apme_mask;
 	driver_intr_t *intr_func;
 	char flowctrl[IFM_ETH_FC_STRLEN];
 
 	adapter->dev = adapter->osdep.dev = dev;
 
+	/*
+	 * Some versions of I219 only have PCI AF.
+	 */
+	if (pci_is_pcie(dev) || pci_find_extcap(dev, PCIY_PCIAF, &cap) == 0)
+		adapter->flags |= EM_FLAG_GEN2;
+
 	callout_init_mp(&adapter->timer);
 	callout_init_mp(&adapter->tx_fifo_timer);
 	callout_init_mp(&adapter->tx_gc_timer);
@@ -559,6 +569,17 @@ em_attach(device_t dev)
 		 * XXX this goof is actually not used.
 		 */
 		adapter->hw.flash_address = (uint8_t *)adapter->flash;
+	} else if (adapter->hw.mac.type == e1000_pch_spt) {
+		/*
+		 * In the new SPT device flash is not a seperate BAR,
+		 * rather it is also in BAR0, so use the same tag and
+		 * an offset handle for the FLASH read/write macros
+		 * in the shared code.
+		 */
+		adapter->osdep.flash_bus_space_tag =
+		    adapter->osdep.mem_bus_space_tag;
+		adapter->osdep.flash_bus_space_handle =
+		    adapter->osdep.mem_bus_space_handle + E1000_FLASH_BASE_ADDR;
 	}
 
 	switch (adapter->hw.mac.type) {
@@ -582,7 +603,7 @@ em_attach(device_t dev)
 		/* FALL THROUGH */
 
 	default:
-		if (pci_is_pcie(dev))
+		if (adapter->flags & EM_FLAG_GEN2)
 			adapter->flags |= EM_FLAG_TSO;
 		break;
 	}
@@ -2077,13 +2098,30 @@ em_set_promisc(struct adapter *adapter)
 static void
 em_disable_promisc(struct adapter *adapter)
 {
+	struct ifnet *ifp = &adapter->arpcom.ac_if;
 	uint32_t reg_rctl;
+	int mcnt = 0;
 
 	reg_rctl = E1000_READ_REG(&adapter->hw, E1000_RCTL);
+	reg_rctl &= ~(E1000_RCTL_UPE | E1000_RCTL_SBP);
+
+	if (ifp->if_flags & IFF_ALLMULTI) {
+		mcnt = MAX_NUM_MULTICAST_ADDRESSES;
+	} else {
+		const struct ifmultiaddr *ifma;
+
+		TAILQ_FOREACH(ifma, &ifp->if_multiaddrs, ifma_link) {
+			if (ifma->ifma_addr->sa_family != AF_LINK)
+				continue;
+			if (mcnt == MAX_NUM_MULTICAST_ADDRESSES)
+				break;
+			mcnt++;
+		}
+	}
+	/* Don't disable if in MAX groups */
+	if (mcnt < MAX_NUM_MULTICAST_ADDRESSES)
+		reg_rctl &= ~E1000_RCTL_MPE;
 
-	reg_rctl &= ~E1000_RCTL_UPE;
-	reg_rctl &= ~E1000_RCTL_MPE;
-	reg_rctl &= ~E1000_RCTL_SBP;
 	E1000_WRITE_REG(&adapter->hw, E1000_RCTL, reg_rctl);
 }
 
@@ -2180,6 +2218,8 @@ em_update_link_status(struct adapter *adapter)
 	switch (hw->phy.media_type) {
 	case e1000_media_type_copper:
 		if (hw->mac.get_link_status) {
+			if (hw->mac.type == e1000_pch_spt)
+				msec_delay(50);
 			/* Do the work to read phy */
 			e1000_check_for_link(hw);
 			link_check = !hw->mac.get_link_status;
@@ -2221,7 +2261,7 @@ em_update_link_status(struct adapter *adapter)
 			int tarc0;
 
 			tarc0 = E1000_READ_REG(hw, E1000_TARC(0));
-			tarc0 &= ~SPEED_MODE_BIT;
+			tarc0 &= ~TARC_SPEED_MODE_BIT;
 			E1000_WRITE_REG(hw, E1000_TARC(0), tarc0);
 		}
 		if (bootverbose) {
@@ -2277,6 +2317,10 @@ em_stop(struct adapter *adapter)
 	adapter->tx_running = 0;
 	callout_stop(&adapter->tx_gc_timer);
 
+	/* I219 needs some special flushing to avoid hangs */
+	if (adapter->hw.mac.type == e1000_pch_spt)
+		em_flush_txrx_ring(adapter);
+
 	e1000_reset_hw(&adapter->hw);
 	if (adapter->hw.mac.type >= e1000_82544)
 		E1000_WRITE_REG(&adapter->hw, E1000_WUC, 0);
@@ -2338,7 +2382,7 @@ em_alloc_pci_res(struct adapter *adapter)
 {
 	device_t dev = adapter->dev;
 	u_int intr_flags;
-	int val, rid, msi_enable, cap;
+	int val, rid, msi_enable;
 
 	/* Enable bus mastering */
 	pci_enable_busmaster(dev);
@@ -2401,13 +2445,10 @@ em_alloc_pci_res(struct adapter *adapter)
 	 *
 	 * Don't enable MSI on 82571/82572, see:
 	 * 82571/82572 specification update errata #63
-	 *
-	 * Some versions of I219 only have PCI AF.
 	 */
 	msi_enable = em_msi_enable;
 	if (msi_enable &&
-	    (!(pci_is_pcie(dev) ||
-	       pci_find_extcap(dev, PCIY_PCIAF, &cap) == 0) ||
+	    ((adapter->flags & EM_FLAG_GEN2) == 0 ||
 	     adapter->hw.mac.type == e1000_82571 ||
 	     adapter->hw.mac.type == e1000_82572))
 		msi_enable = 0;
@@ -2648,6 +2689,10 @@ em_reset(struct adapter *adapter)
 		break;
 	}
 
+	/* I219 needs some special flushing to avoid hangs */
+	if (adapter->hw.mac.type == e1000_pch_spt)
+		em_flush_txrx_ring(adapter);
+
 	/* Issue a global reset */
 	e1000_reset_hw(&adapter->hw);
 	if (adapter->hw.mac.type >= e1000_82544)
@@ -2902,6 +2947,18 @@ em_init_tx_unit(struct adapter *adapter)
 	/* Setup the HW Tx Head and Tail descriptor pointers */
 	E1000_WRITE_REG(&adapter->hw, E1000_TDT(0), 0);
 	E1000_WRITE_REG(&adapter->hw, E1000_TDH(0), 0);
+	if (adapter->flags & EM_FLAG_GEN2) {
+		uint32_t txdctl = 0;
+
+		txdctl |= 0x1f;		/* PTHRESH */
+		txdctl |= 1 << 8;	/* HTHRESH */
+		txdctl |= 1 << 16;	/* WTHRESH */
+		txdctl |= 1 << 22;	/* Reserved bit 22 must always be 1 */
+		txdctl |= E1000_TXDCTL_GRAN;
+		txdctl |= 1 << 25;	/* LWTHRESH */
+
+		E1000_WRITE_REG(&adapter->hw, E1000_TXDCTL(0), txdctl);
+	}
 
 	/* Set the default values for the Tx Inter Packet Gap timer */
 	switch (adapter->hw.mac.type) {
@@ -2939,15 +2996,20 @@ em_init_tx_unit(struct adapter *adapter)
 	if (adapter->hw.mac.type == e1000_82571 ||
 	    adapter->hw.mac.type == e1000_82572) {
 		tarc = E1000_READ_REG(&adapter->hw, E1000_TARC(0));
-		tarc |= SPEED_MODE_BIT;
+		tarc |= TARC_SPEED_MODE_BIT;
 		E1000_WRITE_REG(&adapter->hw, E1000_TARC(0), tarc);
 	} else if (adapter->hw.mac.type == e1000_80003es2lan) {
+		/* errata: program both queues to unweighted RR */
 		tarc = E1000_READ_REG(&adapter->hw, E1000_TARC(0));
 		tarc |= 1;
 		E1000_WRITE_REG(&adapter->hw, E1000_TARC(0), tarc);
 		tarc = E1000_READ_REG(&adapter->hw, E1000_TARC(1));
 		tarc |= 1;
 		E1000_WRITE_REG(&adapter->hw, E1000_TARC(1), tarc);
+	} else if (adapter->hw.mac.type == e1000_82574) {
+		tarc = E1000_READ_REG(&adapter->hw, E1000_TARC(0));
+		tarc |= TARC_ERRATA_BIT;
+		E1000_WRITE_REG(&adapter->hw, E1000_TARC(0), tarc);
 	}
 
 	/* Program the Transmit Control Register */
@@ -2969,6 +3031,15 @@ em_init_tx_unit(struct adapter *adapter)
 		tarc = E1000_READ_REG(&adapter->hw, E1000_TARC(1));
 		tarc &= ~(1 << 28);
 		E1000_WRITE_REG(&adapter->hw, E1000_TARC(1), tarc);
+	} else if (adapter->hw.mac.type == e1000_pch_spt) {
+		uint32_t reg;
+
+		reg = E1000_READ_REG(&adapter->hw, E1000_IOSFPC);
+		reg |= E1000_RCTL_RDMTS_HEX;
+		E1000_WRITE_REG(&adapter->hw, E1000_IOSFPC, reg);
+		reg = E1000_READ_REG(&adapter->hw, E1000_TARC(0));
+		reg |= E1000_TARC0_CB_MULTIQ_3_REQ;
+		E1000_WRITE_REG(&adapter->hw, E1000_TARC(0), reg);
 	}
 }
 
@@ -3388,14 +3459,17 @@ em_init_rx_unit(struct adapter *adapter)
 {
 	struct ifnet *ifp = &adapter->arpcom.ac_if;
 	uint64_t bus_addr;
-	uint32_t rctl;
+	uint32_t rctl, rxcsum;
 
 	/*
 	 * Make sure receives are disabled while setting
 	 * up the descriptor ring
 	 */
 	rctl = E1000_READ_REG(&adapter->hw, E1000_RCTL);
-	E1000_WRITE_REG(&adapter->hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+	/* Do not disable if ever enabled on this hardware */
+	if (adapter->hw.mac.type != e1000_82574 &&
+	    adapter->hw.mac.type != e1000_82583)
+		E1000_WRITE_REG(&adapter->hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
 
 	if (adapter->hw.mac.type >= e1000_82540) {
 		uint32_t itr;
@@ -3413,18 +3487,20 @@ em_init_rx_unit(struct adapter *adapter)
 
 	/* Disable accelerated ackknowledge */
 	if (adapter->hw.mac.type == e1000_82574) {
-		E1000_WRITE_REG(&adapter->hw,
-		    E1000_RFCTL, E1000_RFCTL_ACK_DIS);
-	}
+		uint32_t rfctl;
 
-	/* Receive Checksum Offload for TCP and UDP */
-	if (ifp->if_capenable & IFCAP_RXCSUM) {
-		uint32_t rxcsum;
+		rfctl = E1000_READ_REG(&adapter->hw, E1000_RFCTL);
+		rfctl |= E1000_RFCTL_ACK_DIS;
+		E1000_WRITE_REG(&adapter->hw, E1000_RFCTL, rfctl);
+	}
 
-		rxcsum = E1000_READ_REG(&adapter->hw, E1000_RXCSUM);
+	/* Receive Checksum Offload for IP and TCP/UDP */
+	rxcsum = E1000_READ_REG(&adapter->hw, E1000_RXCSUM);
+	if (ifp->if_capenable & IFCAP_RXCSUM)
 		rxcsum |= (E1000_RXCSUM_IPOFL | E1000_RXCSUM_TUOFL);
-		E1000_WRITE_REG(&adapter->hw, E1000_RXCSUM, rxcsum);
-	}
+	else
+		rxcsum &= ~(E1000_RXCSUM_IPOFL | E1000_RXCSUM_TUOFL);
+	E1000_WRITE_REG(&adapter->hw, E1000_RXCSUM, rxcsum);
 
 	/*
 	 * XXX TEMPORARY WORKAROUND: on some systems with 82573
@@ -3456,14 +3532,23 @@ em_init_rx_unit(struct adapter *adapter)
 	E1000_WRITE_REG(&adapter->hw, E1000_RDT(0), adapter->num_rx_desc - 1);
 
 	/* Set PTHRESH for improved jumbo performance */
-	if (((adapter->hw.mac.type == e1000_ich9lan) ||
-	    (adapter->hw.mac.type == e1000_pch2lan) ||
-	    (adapter->hw.mac.type == e1000_ich10lan)) &&
-	    (ifp->if_mtu > ETHERMTU)) {
+	if (ifp->if_mtu > ETHERMTU) {
 		uint32_t rxdctl;
 
-		rxdctl = E1000_READ_REG(&adapter->hw, E1000_RXDCTL(0));
-		E1000_WRITE_REG(&adapter->hw, E1000_RXDCTL(0), rxdctl | 3);
+		if (adapter->hw.mac.type == e1000_ich9lan ||
+		    adapter->hw.mac.type == e1000_pch2lan ||
+		    adapter->hw.mac.type == e1000_ich10lan) {
+			rxdctl = E1000_READ_REG(&adapter->hw, E1000_RXDCTL(0));
+			E1000_WRITE_REG(&adapter->hw, E1000_RXDCTL(0),
+			    rxdctl | 3);
+		} else if (adapter->hw.mac.type == e1000_82574) {
+			rxdctl = E1000_READ_REG(&adapter->hw, E1000_RXDCTL(0));
+                	rxdctl |= 0x20;		/* PTHRESH */
+                	rxdctl |= 4 << 8;	/* HTHRESH */
+                	rxdctl |= 4 << 16;	/* WTHRESH */
+			rxdctl |= 1 << 24;	/* Switch to granularity */
+			E1000_WRITE_REG(&adapter->hw, E1000_RXDCTL(0), rxdctl);
+		}
 	}
 
 	if (adapter->hw.mac.type >= e1000_pch2lan) {
@@ -4559,3 +4644,109 @@ em_tso_setup(struct adapter *adapter, struct mbuf *mp,
 	adapter->next_avail_tx_desc = curr_txd;
 	return 1;
 }
+
+/*
+ * Remove all descriptors from the TX ring.
+ *
+ * We want to clear all pending descriptors from the TX ring.  Zeroing
+ * happens when the HW reads the regs.  We assign the ring itself as
+ * the data of the next descriptor.  We don't care about the data we
+ * are about to reset the HW.
+ */
+static void
+em_flush_tx_ring(struct adapter *adapter)
+{
+	struct e1000_hw *hw = &adapter->hw;
+	struct e1000_tx_desc *txd;
+	uint32_t tctl;
+
+	tctl = E1000_READ_REG(hw, E1000_TCTL);
+	E1000_WRITE_REG(hw, E1000_TCTL, tctl | E1000_TCTL_EN);
+
+	txd = &adapter->tx_desc_base[adapter->next_avail_tx_desc++];
+	if (adapter->next_avail_tx_desc == adapter->num_tx_desc)
+		adapter->next_avail_tx_desc = 0;
+
+	/* Just use the ring as a dummy buffer addr */
+	txd->buffer_addr = adapter->txdma.dma_paddr;
+	txd->lower.data = htole32(E1000_TXD_CMD_IFCS | 512);
+	txd->upper.data = 0;
+
+	E1000_WRITE_REG(hw, E1000_TDT(0), adapter->next_avail_tx_desc);
+	usec_delay(250);
+}
+
+/*
+ * Remove all descriptors from the RX ring.
+ *
+ * Mark all descriptors in the RX ring as consumed and disable the RX ring.
+ */
+static void
+em_flush_rx_ring(struct adapter *adapter)
+{
+	struct e1000_hw	*hw = &adapter->hw;
+	uint32_t rctl, rxdctl;
+
+	rctl = E1000_READ_REG(hw, E1000_RCTL);
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+	E1000_WRITE_FLUSH(hw);
+	usec_delay(150);
+
+	rxdctl = E1000_READ_REG(hw, E1000_RXDCTL(0));
+	/* Zero the lower 14 bits (prefetch and host thresholds) */
+	rxdctl &= 0xffffc000;
+	/*
+	 * Update thresholds: prefetch threshold to 31, host threshold to 1
+	 * and make sure the granularity is "descriptors" and not "cache
+	 * lines".
+	 */
+	rxdctl |= (0x1F | (1 << 8) | E1000_RXDCTL_THRESH_UNIT_DESC);
+	E1000_WRITE_REG(hw, E1000_RXDCTL(0), rxdctl);
+
+	/* Momentarily enable the RX ring for the changes to take effect */
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl | E1000_RCTL_EN);
+	E1000_WRITE_FLUSH(hw);
+	usec_delay(150);
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+}
+
+/*
+ * Remove all descriptors from the descriptor rings.
+ *
+ * In i219, the descriptor rings must be emptied before resetting the HW
+ * or before changing the device state to D3 during runtime (runtime PM).
+ *
+ * Failure to do this will cause the HW to enter a unit hang state which
+ * can only be released by PCI reset on the device.
+ */
+static void
+em_flush_txrx_ring(struct adapter *adapter)
+{
+	struct e1000_hw *hw = &adapter->hw;
+	device_t dev = adapter->dev;
+	uint16_t hang_state;
+	uint32_t fext_nvm11;
+
+	/*
+	 * First, disable MULR fix in FEXTNVM11.
+	 */
+	fext_nvm11 = E1000_READ_REG(hw, E1000_FEXTNVM11);
+	fext_nvm11 |= E1000_FEXTNVM11_DISABLE_MULR_FIX;
+	E1000_WRITE_REG(hw, E1000_FEXTNVM11, fext_nvm11);
+
+	/* 
+	 * Do nothing if we're not in faulty state, or if the queue is
+	 * empty.
+	 */
+	hang_state = pci_read_config(dev, PCICFG_DESC_RING_STATUS, 2);
+	if ((hang_state & FLUSH_DESC_REQUIRED) &&
+	    E1000_READ_REG(hw, E1000_TDLEN(0)))
+		em_flush_tx_ring(adapter);
+
+	/*
+	 * Recheck, maybe the fault is caused by the RX ring.
+	 */
+	hang_state = pci_read_config(dev, PCICFG_DESC_RING_STATUS, 2);
+	if (hang_state & FLUSH_DESC_REQUIRED)
+		em_flush_rx_ring(adapter);
+}
diff --git a/sys/dev/netif/em/if_em.h b/sys/dev/netif/em/if_em.h
index 2fc84c6b21..eaa475d248 100644
--- a/sys/dev/netif/em/if_em.h
+++ b/sys/dev/netif/em/if_em.h
@@ -191,6 +191,9 @@
 #define EM_FC_PAUSE_TIME		1000
 #define EM_EEPROM_APME			0x400;
 
+#define PCICFG_DESC_RING_STATUS		0xe4
+#define FLUSH_DESC_REQUIRED		0x100
+
 /*
  * TDBA/RDBA should be aligned on 16 byte boundary. But TDLEN/RDLEN should be
  * multiple of 128 bytes. So we align TDBA/RDBA on 128 byte boundary. This will
@@ -198,7 +201,8 @@
  */
 #define EM_DBA_ALIGN			128
 
-#define SPEED_MODE_BIT			(1 << 21) /* On PCI-E MACs only */
+#define TARC_SPEED_MODE_BIT		(1 << 21) /* On PCI-E MACs only */
+#define TARC_ERRATA_BIT			(1 << 26) /* Note from errata on 82574 */
 
 /* PCI Config defines */
 #define EM_BAR_TYPE(v)			((v) & EM_BAR_TYPE_MASK)
@@ -255,6 +259,7 @@ struct adapter {
 #define EM_FLAG_HW_CTRL		0x0008
 #define EM_FLAG_TSO		0x0010
 #define EM_FLAG_TSO_PULLEX	0x0020
+#define EM_FLAG_GEN2		0x0040
 
 	/* DragonFly operating-system-specific structures. */
 	struct e1000_osdep	osdep;
diff --git a/sys/dev/netif/emx/if_emx.c b/sys/dev/netif/emx/if_emx.c
index 06469628f7..061ebea01f 100644
--- a/sys/dev/netif/emx/if_emx.c
+++ b/sys/dev/netif/emx/if_emx.c
@@ -175,7 +175,7 @@ static const struct emx_device {
 	EMX_DEVICE(PCH_SPT_I219_V),
 	EMX_DEVICE(PCH_SPT_I219_LM2),
 	EMX_DEVICE(PCH_SPT_I219_V2),
-	EMX_DEVICE(PCH_SPT_I219_LM3),
+	EMX_DEVICE(PCH_LBG_I219_LM3),
 	EMX_DEVICE(PCH_SPT_I219_LM4),
 	EMX_DEVICE(PCH_SPT_I219_V4),
 	EMX_DEVICE(PCH_SPT_I219_LM5),
@@ -257,6 +257,9 @@ static void	emx_update_link_status(struct emx_softc *);
 static void	emx_smartspeed(struct emx_softc *);
 static void	emx_set_itr(struct emx_softc *, uint32_t);
 static void	emx_disable_aspm(struct emx_softc *);
+static void	emx_flush_tx_ring(struct emx_softc *);
+static void	emx_flush_rx_ring(struct emx_softc *);
+static void	emx_flush_txrx_ring(struct emx_softc *);
 
 static void	emx_print_debug_info(struct emx_softc *);
 static void	emx_print_nvm_info(struct emx_softc *);
@@ -665,6 +668,16 @@ again:
 		 * XXX this goof is actually not used.
 		 */
 		sc->hw.flash_address = (uint8_t *)sc->flash;
+	} else if (sc->hw.mac.type == e1000_pch_spt) {
+		/*
+		 * In the new SPT device flash is not a seperate BAR,
+		 * rather it is also in BAR0, so use the same tag and
+		 * an offset handle for the FLASH read/write macros
+		 * in the shared code.
+		 */
+		sc->osdep.flash_bus_space_tag = sc->osdep.mem_bus_space_tag;
+		sc->osdep.flash_bus_space_handle =
+		    sc->osdep.mem_bus_space_handle + E1000_FLASH_BASE_ADDR;
 	}
 
 	/* Do Shared Code initialization */
@@ -1791,13 +1804,30 @@ emx_set_promisc(struct emx_softc *sc)
 static void
 emx_disable_promisc(struct emx_softc *sc)
 {
+	struct ifnet *ifp = &sc->arpcom.ac_if;
 	uint32_t reg_rctl;
+	int mcnt = 0;
 
 	reg_rctl = E1000_READ_REG(&sc->hw, E1000_RCTL);
+	reg_rctl &= ~(E1000_RCTL_UPE | E1000_RCTL_SBP);
+
+	if (ifp->if_flags & IFF_ALLMULTI) {
+		mcnt = EMX_MCAST_ADDR_MAX;
+	} else {
+		const struct ifmultiaddr *ifma;
+
+		TAILQ_FOREACH(ifma, &ifp->if_multiaddrs, ifma_link) {
+			if (ifma->ifma_addr->sa_family != AF_LINK)
+				continue;
+			if (mcnt == EMX_MCAST_ADDR_MAX)
+				break;
+			mcnt++;
+		}
+	}
+	/* Don't disable if in MAX groups */
+	if (mcnt < EMX_MCAST_ADDR_MAX)
+		reg_rctl &= ~E1000_RCTL_MPE;
 
-	reg_rctl &= ~E1000_RCTL_UPE;
-	reg_rctl &= ~E1000_RCTL_MPE;
-	reg_rctl &= ~E1000_RCTL_SBP;
 	E1000_WRITE_REG(&sc->hw, E1000_RCTL, reg_rctl);
 }
 
@@ -1874,6 +1904,8 @@ emx_update_link_status(struct emx_softc *sc)
 	switch (hw->phy.media_type) {
 	case e1000_media_type_copper:
 		if (hw->mac.get_link_status) {
+			if (hw->mac.type == e1000_pch_spt)
+				msec_delay(50);
 			/* Do the work to read phy */
 			e1000_check_for_link(hw);
 			link_check = !hw->mac.get_link_status;
@@ -1971,6 +2003,10 @@ emx_stop(struct emx_softc *sc)
 		callout_stop(&tdata->tx_gc_timer);
 	}
 
+	/* I219 needs some special flushing to avoid hangs */
+	if (sc->hw.mac.type == e1000_pch_spt)
+		emx_flush_txrx_ring(sc);
+
 	/*
 	 * Disable multiple receive queues.
 	 *
@@ -2087,6 +2123,10 @@ emx_reset(struct emx_softc *sc)
 		sc->hw.fc.pause_time = 0xFFFF;
 	}
 
+	/* I219 needs some special flushing to avoid hangs */
+	if (sc->hw.mac.type == e1000_pch_spt)
+		emx_flush_txrx_ring(sc);
+
 	/* Issue a global reset */
 	e1000_reset_hw(&sc->hw);
 	E1000_WRITE_REG(&sc->hw, E1000_WUC, 0);
@@ -2410,6 +2450,15 @@ emx_init_tx_unit(struct emx_softc *sc)
 		/* Setup the HW Tx Head and Tail descriptor pointers */
 		E1000_WRITE_REG(&sc->hw, E1000_TDT(i), 0);
 		E1000_WRITE_REG(&sc->hw, E1000_TDH(i), 0);
+
+		txdctl = 0x1f;		/* PTHRESH */
+		txdctl |= 1 << 8;	/* HTHRESH */
+		txdctl |= 1 << 16;	/* WTHRESH */
+		txdctl |= 1 << 22;	/* Reserved bit 22 must always be 1 */
+		txdctl |= E1000_TXDCTL_GRAN;
+		txdctl |= 1 << 25;	/* LWTHRESH */
+
+		E1000_WRITE_REG(&sc->hw, E1000_TXDCTL(i), txdctl);
 	}
 
 	/* Set the default values for the Tx Inter Packet Gap timer */
@@ -2451,12 +2500,23 @@ emx_init_tx_unit(struct emx_softc *sc)
 		tarc |= EMX_TARC_SPEED_MODE;
 		E1000_WRITE_REG(&sc->hw, E1000_TARC(0), tarc);
 	} else if (sc->hw.mac.type == e1000_80003es2lan) {
+		/* errata: program both queues to unweighted RR */
 		tarc = E1000_READ_REG(&sc->hw, E1000_TARC(0));
 		tarc |= 1;
 		E1000_WRITE_REG(&sc->hw, E1000_TARC(0), tarc);
 		tarc = E1000_READ_REG(&sc->hw, E1000_TARC(1));
 		tarc |= 1;
 		E1000_WRITE_REG(&sc->hw, E1000_TARC(1), tarc);
+	} else if (sc->hw.mac.type == e1000_82574) {
+		tarc = E1000_READ_REG(&sc->hw, E1000_TARC(0));
+		tarc |= EMX_TARC_ERRATA;
+		if (sc->tx_ring_inuse > 1) {
+			tarc |= (EMX_TARC_COMPENSATION_MODE | EMX_TARC_MQ_FIX);
+			E1000_WRITE_REG(&sc->hw, E1000_TARC(0), tarc);
+			E1000_WRITE_REG(&sc->hw, E1000_TARC(1), tarc);
+		} else {
+			E1000_WRITE_REG(&sc->hw, E1000_TARC(0), tarc);
+		}
 	}
 
 	/* Program the Transmit Control Register */
@@ -2476,6 +2536,15 @@ emx_init_tx_unit(struct emx_softc *sc)
 		tarc = E1000_READ_REG(&sc->hw, E1000_TARC(1));
 		tarc &= ~(1 << 28);
 		E1000_WRITE_REG(&sc->hw, E1000_TARC(1), tarc);
+	} else if (sc->hw.mac.type == e1000_pch_spt) {
+		uint32_t reg;
+
+		reg = E1000_READ_REG(&sc->hw, E1000_IOSFPC);
+		reg |= E1000_RCTL_RDMTS_HEX;
+		E1000_WRITE_REG(&sc->hw, E1000_IOSFPC, reg);
+		reg = E1000_READ_REG(&sc->hw, E1000_TARC(0));
+		reg |= E1000_TARC0_CB_MULTIQ_3_REQ;
+		E1000_WRITE_REG(&sc->hw, E1000_TARC(0), reg);
 	}
 
 	if (sc->tx_ring_inuse > 1) {
@@ -2997,7 +3066,7 @@ emx_init_rx_unit(struct emx_softc *sc)
 {
 	struct ifnet *ifp = &sc->arpcom.ac_if;
 	uint64_t bus_addr;
-	uint32_t rctl, itr, rfctl;
+	uint32_t rctl, itr, rfctl, rxcsum;
 	int i;
 
 	/*
@@ -3005,7 +3074,9 @@ emx_init_rx_unit(struct emx_softc *sc)
 	 * up the descriptor ring
 	 */
 	rctl = E1000_READ_REG(&sc->hw, E1000_RCTL);
-	E1000_WRITE_REG(&sc->hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+	/* Do not disable if ever enabled on this hardware */
+	if (sc->hw.mac.type != e1000_82574)
+		E1000_WRITE_REG(&sc->hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
 
 	/*
 	 * Set the interrupt throttling rate. Value is calculated
@@ -3018,12 +3089,11 @@ emx_init_rx_unit(struct emx_softc *sc)
 	emx_set_itr(sc, itr);
 
 	/* Use extended RX descriptor */
-	rfctl = E1000_RFCTL_EXTEN;
-
+	rfctl = E1000_READ_REG(&sc->hw, E1000_RFCTL);
+	rfctl |= E1000_RFCTL_EXTEN;
 	/* Disable accelerated ackknowledge */
 	if (sc->hw.mac.type == e1000_82574)
 		rfctl |= E1000_RFCTL_ACK_DIS;
-
 	E1000_WRITE_REG(&sc->hw, E1000_RFCTL, rfctl);
 
 	/*
@@ -3033,12 +3103,9 @@ emx_init_rx_unit(struct emx_softc *sc)
 	 * queue is to be supported, since we need it to figure out
 	 * packet type.
 	 */
+	rxcsum = E1000_READ_REG(&sc->hw, E1000_RXCSUM);
 	if ((ifp->if_capenable & IFCAP_RXCSUM) ||
 	    sc->rx_ring_cnt > 1) {
-		uint32_t rxcsum;
-
-		rxcsum = E1000_READ_REG(&sc->hw, E1000_RXCSUM);
-
 		/*
 		 * NOTE:
 		 * PCSD must be enabled to enable multiple
@@ -3046,8 +3113,11 @@ emx_init_rx_unit(struct emx_softc *sc)
 		 */
 		rxcsum |= E1000_RXCSUM_IPOFL | E1000_RXCSUM_TUOFL |
 			  E1000_RXCSUM_PCSD;
-		E1000_WRITE_REG(&sc->hw, E1000_RXCSUM, rxcsum);
+	} else {
+		rxcsum &= ~(E1000_RXCSUM_IPOFL | E1000_RXCSUM_TUOFL |
+			    E1000_RXCSUM_PCSD);
 	}
+	E1000_WRITE_REG(&sc->hw, E1000_RXCSUM, rxcsum);
 
 	/*
 	 * Configure multiple receive queue (RSS)
@@ -3145,6 +3215,20 @@ emx_init_rx_unit(struct emx_softc *sc)
 		    sc->rx_data[i].num_rx_desc - 1);
 	}
 
+	/* Set PTHRESH for improved jumbo performance */
+	if (ifp->if_mtu > ETHERMTU && sc->hw.mac.type == e1000_82574) {
+		uint32_t rxdctl;
+
+		for (i = 0; i < sc->rx_ring_cnt; ++i) {
+			rxdctl = E1000_READ_REG(&sc->hw, E1000_RXDCTL(i));
+                	rxdctl |= 0x20;		/* PTHRESH */
+                	rxdctl |= 4 << 8;	/* HTHRESH */
+                	rxdctl |= 4 << 16;	/* WTHRESH */
+			rxdctl |= 1 << 24;	/* Switch to granularity */
+			E1000_WRITE_REG(&sc->hw, E1000_RXDCTL(i), rxdctl);
+		}
+	}
+
 	if (sc->hw.mac.type >= e1000_pch2lan) {
 		if (ifp->if_mtu > ETHERMTU)
 			e1000_lv_jumbo_workaround_ich8lan(&sc->hw, TRUE);
@@ -4361,3 +4445,125 @@ emx_get_txring_inuse(const struct emx_softc *sc, boolean_t polling)
 	else
 		return 1;
 }
+
+/*
+ * Remove all descriptors from the TX ring.
+ *
+ * We want to clear all pending descriptors from the TX ring.  Zeroing
+ * happens when the HW reads the regs.  We assign the ring itself as
+ * the data of the next descriptor.  We don't care about the data we
+ * are about to reset the HW.
+ */
+static void
+emx_flush_tx_ring(struct emx_softc *sc)
+{
+	struct e1000_hw *hw = &sc->hw;
+	uint32_t tctl;
+	int i;
+
+	tctl = E1000_READ_REG(hw, E1000_TCTL);
+	E1000_WRITE_REG(hw, E1000_TCTL, tctl | E1000_TCTL_EN);
+
+	for (i = 0; i < sc->tx_ring_inuse; ++i) {
+		struct emx_txdata *tdata = &sc->tx_data[i];
+		struct e1000_tx_desc *txd;
+
+		if (E1000_READ_REG(hw, E1000_TDLEN(i)) == 0)
+			continue;
+
+		txd = &tdata->tx_desc_base[tdata->next_avail_tx_desc++];
+		if (tdata->next_avail_tx_desc == tdata->num_tx_desc)
+			tdata->next_avail_tx_desc = 0;
+
+		/* Just use the ring as a dummy buffer addr */
+		txd->buffer_addr = tdata->tx_desc_paddr;
+		txd->lower.data = htole32(E1000_TXD_CMD_IFCS | 512);
+		txd->upper.data = 0;
+
+		E1000_WRITE_REG(hw, E1000_TDT(i), tdata->next_avail_tx_desc);
+		usec_delay(250);
+	}
+}
+
+/*
+ * Remove all descriptors from the RX rings.
+ *
+ * Mark all descriptors in the RX rings as consumed and disable the RX rings.
+ */
+static void
+emx_flush_rx_ring(struct emx_softc *sc)
+{
+	struct e1000_hw	*hw = &sc->hw;
+	uint32_t rctl;
+	int i;
+
+	rctl = E1000_READ_REG(hw, E1000_RCTL);
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+	E1000_WRITE_FLUSH(hw);
+	usec_delay(150);
+
+	for (i = 0; i < sc->rx_ring_cnt; ++i) {
+		uint32_t rxdctl;
+
+		rxdctl = E1000_READ_REG(hw, E1000_RXDCTL(i));
+		/* Zero the lower 14 bits (prefetch and host thresholds) */
+		rxdctl &= 0xffffc000;
+		/*
+		 * Update thresholds: prefetch threshold to 31, host threshold
+		 * to 1 and make sure the granularity is "descriptors" and not
+		 * "cache lines".
+		 */
+		rxdctl |= (0x1F | (1 << 8) | E1000_RXDCTL_THRESH_UNIT_DESC);
+		E1000_WRITE_REG(hw, E1000_RXDCTL(i), rxdctl);
+	}
+
+	/* Momentarily enable the RX rings for the changes to take effect */
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl | E1000_RCTL_EN);
+	E1000_WRITE_FLUSH(hw);
+	usec_delay(150);
+	E1000_WRITE_REG(hw, E1000_RCTL, rctl & ~E1000_RCTL_EN);
+}
+
+/*
+ * Remove all descriptors from the descriptor rings.
+ *
+ * In i219, the descriptor rings must be emptied before resetting the HW
+ * or before changing the device state to D3 during runtime (runtime PM).
+ *
+ * Failure to do this will cause the HW to enter a unit hang state which
+ * can only be released by PCI reset on the device.
+ */
+static void
+emx_flush_txrx_ring(struct emx_softc *sc)
+{
+	struct e1000_hw *hw = &sc->hw;
+	device_t dev = sc->dev;
+	uint16_t hang_state;
+	uint32_t fext_nvm11, tdlen;
+	int i;
+
+	/*
+	 * First, disable MULR fix in FEXTNVM11.
+	 */
+	fext_nvm11 = E1000_READ_REG(hw, E1000_FEXTNVM11);
+	fext_nvm11 |= E1000_FEXTNVM11_DISABLE_MULR_FIX;
+	E1000_WRITE_REG(hw, E1000_FEXTNVM11, fext_nvm11);
+
+	/* 
+	 * Do nothing if we're not in faulty state, or if the queue is
+	 * empty.
+	 */
+	tdlen = 0;
+	for (i = 0; i < sc->tx_ring_inuse; ++i)
+		tdlen += E1000_READ_REG(hw, E1000_TDLEN(i));
+	hang_state = pci_read_config(dev, EMX_PCICFG_DESC_RING_STATUS, 2);
+	if ((hang_state & EMX_FLUSH_DESC_REQUIRED) && tdlen)
+		emx_flush_tx_ring(sc);
+
+	/*
+	 * Recheck, maybe the fault is caused by the RX ring.
+	 */
+	hang_state = pci_read_config(dev, EMX_PCICFG_DESC_RING_STATUS, 2);
+	if (hang_state & EMX_FLUSH_DESC_REQUIRED)
+		emx_flush_rx_ring(sc);
+}
diff --git a/sys/dev/netif/emx/if_emx.h b/sys/dev/netif/emx/if_emx.h
index 9d416e5eac..c25be0565f 100644
--- a/sys/dev/netif/emx/if_emx.h
+++ b/sys/dev/netif/emx/if_emx.h
@@ -140,6 +140,9 @@
 #define EMX_FC_PAUSE_TIME		1000
 #define EMX_EEPROM_APME			0x400;
 
+#define EMX_PCICFG_DESC_RING_STATUS	0xe4
+#define EMX_FLUSH_DESC_REQUIRED		0x100
+
 /*
  * TDBA/RDBA should be aligned on 16 byte boundary. But TDLEN/RDLEN should be
  * multiple of 128 bytes. So we align TDBA/RDBA on 128 byte boundary. This will
@@ -153,6 +156,13 @@
  */
 #define EMX_TARC_SPEED_MODE		(1 << 21)
 
+#define EMX_TARC_COMPENSATION_MODE	(1 << 7) /* Compensation Mode */
+
+#define EMX_TARC_MQ_FIX			(1 << 23) | \
+					(1 << 24) | \
+					(1 << 25) /* Handle errata in MQ mode */
+#define EMX_TARC_ERRATA 		(1 << 26) /* 82574 errata */
+
 /*
  * Multiple TX queues arbitration count mask in TARC0/TARC1.
  */
diff --git a/sys/dev/netif/ig_hal/e1000_80003es2lan.c b/sys/dev/netif/ig_hal/e1000_80003es2lan.c
index eb45158176..e7c42d5386 100644
--- a/sys/dev/netif/ig_hal/e1000_80003es2lan.c
+++ b/sys/dev/netif/ig_hal/e1000_80003es2lan.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /* 80003ES2LAN Gigabit Ethernet Controller (Copper)
  * 80003ES2LAN Gigabit Ethernet Controller (Serdes)
diff --git a/sys/dev/netif/ig_hal/e1000_80003es2lan.h b/sys/dev/netif/ig_hal/e1000_80003es2lan.h
index ae923c7811..89b15512bf 100644
--- a/sys/dev/netif/ig_hal/e1000_80003es2lan.h
+++ b/sys/dev/netif/ig_hal/e1000_80003es2lan.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_80003ES2LAN_H_
 #define _E1000_80003ES2LAN_H_
diff --git a/sys/dev/netif/ig_hal/e1000_82540.c b/sys/dev/netif/ig_hal/e1000_82540.c
index efa95233d2..2d03b8ff8e 100644
--- a/sys/dev/netif/ig_hal/e1000_82540.c
+++ b/sys/dev/netif/ig_hal/e1000_82540.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /*
  * 82540EM Gigabit Ethernet Controller
diff --git a/sys/dev/netif/ig_hal/e1000_82541.c b/sys/dev/netif/ig_hal/e1000_82541.c
index 7483dd2587..c8ac3561a2 100644
--- a/sys/dev/netif/ig_hal/e1000_82541.c
+++ b/sys/dev/netif/ig_hal/e1000_82541.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /*
  * 82541EI Gigabit Ethernet Controller
diff --git a/sys/dev/netif/ig_hal/e1000_82541.h b/sys/dev/netif/ig_hal/e1000_82541.h
index df06f0f8cd..7a01fd43ad 100644
--- a/sys/dev/netif/ig_hal/e1000_82541.h
+++ b/sys/dev/netif/ig_hal/e1000_82541.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_82541_H_
 #define _E1000_82541_H_
